#include <stdio.h>
#include <string.h>
#include <ncurses.h>
#include <time.h>
#include "defs.h"


void special_print(int chann);

void init_curses(void) {

    initscr();  // init stdscr
    getmaxyx(stdscr,max_y,max_x); // get max x,y ..err y,x ... testa lgg in i main

    noecho();
    raw();

    printf("\033[?25l");    // hide the cursor in term's (and console)... replaces curs_set()
    printf("\033[?30l");    // hide scrollbar
}

void kill_curses(void) {

    printf("\033[?25h");    // make the cursor visible again
    //printf("\033[?30h");    
    endwin();

}


void print_time(int maxx) {

    time_t         t;
    //char   timestr[30];
    char		*timestr;

    t = time(NULL); 
    //ctime_r(&t,timestr);
    timestr = ctime(&t);

    timestr[16]='\0';  // we wont need the year.. 
    if (has_colors() == TRUE && colorcfg == 1) {
        attron(COLOR_PAIR(4));  // print with nice colors
    }
    mvprintw(bordercfg,maxx-18,"%s",timestr); // y=1 och vnsterjusterat
}

void print_channels(void) {

    int i,j=0;

    if (has_colors() == TRUE && colorcfg == 1) {
        attron(COLOR_PAIR(1)); // set the color attrib 
    }
    for (i=0; i<16; i++) {
        if (kanaler[i].used != 1) break;
        mvprintw(topspacecfg+clockcfg+j,1+bordercfg,"%s",kanaler[i].name);
        j++;
    }
}

void actual_print(int chann, int i) {
    char tempstr[32];
    memset(tempstr, ' ', 32);

    if (kanaler[chann].program[i][0] == '\0') return;

    if (has_colors() == TRUE && colorcfg == 1)
        attron(COLOR_PAIR(2));
    mvprintw(topspacecfg+clockcfg+chann,14+bordercfg,"%.2d:%.2d ",(kanaler[chann].starttid[i] - kanaler[chann].starttid[i]%60)/60, kanaler[chann].starttid[i]%60, kanaler[chann].program[i]);

    if (has_colors() == TRUE && colorcfg == 1) 
        attron(COLOR_PAIR(5));       
    if (kanaler[chann].program[i+1][0])
        mvprintw(topspacecfg+clockcfg+chann,53+bordercfg,"%.2d:%.2d ",(kanaler[chann].starttid[i+1] - kanaler[chann].starttid[i+1]%60)/60, kanaler[chann].starttid[i+1]%60, kanaler[chann].program[i+1]);
    else
        mvprintw(topspacecfg+clockcfg+chann,53+bordercfg,"      ");
    if (kanaler[chann].watch[i] == 1)
        attron(A_BOLD);  
    if (has_colors() == TRUE && colorcfg == 1) 
        attron(COLOR_PAIR(3));

    strncpy(tempstr, kanaler[chann].program[i], strlen(kanaler[chann].program[i])); //padding
    tempstr[31] = '\0';

    mvprintw(topspacecfg+clockcfg+chann,20+bordercfg,"%s", tempstr);
    attroff(A_BOLD); 

    if (kanaler[chann].watch[i+1] == 1) 
        attron(A_BOLD);

    if (has_colors() == TRUE && colorcfg == 1)
        attron(COLOR_PAIR(6));       

    memset(tempstr, ' ', 32);
    if (kanaler[chann].program[i+1][0]) 
        strncpy(tempstr, kanaler[chann].program[i+1], strlen(kanaler[chann].program[i+1])); //padding
    tempstr[31] = '\0';

    if (max_x-(59+bordercfg) < 32) 
        tempstr[max_x-(59+bordercfg)-1] = '\0';
    mvprintw(topspacecfg+clockcfg+chann,59+bordercfg,"%s", tempstr);  
    attroff(A_BOLD);
}

void special_print(int chann) {

    char tempstr[32];
    memset(tempstr, ' ', 32);

    if (has_colors() == TRUE && colorcfg == 1) {
        attron(COLOR_PAIR(5));
    }
    mvprintw(topspacecfg+clockcfg+chann,53+bordercfg,"%.2d:%.2d ",(kanaler[chann].starttid[0] - kanaler[chann].starttid[0]%60)/60, kanaler[chann].starttid[0]%60, kanaler[chann].program[0]);

    if (kanaler[chann].watch[0] == 1) {
        attron(A_BOLD);
    }
    if (has_colors() == TRUE && colorcfg == 1) {
        attron(COLOR_PAIR(6));
    }
    mvprintw(topspacecfg+clockcfg+chann,14+bordercfg,"                                     "); /* clear the current field */


    strncpy(tempstr,kanaler[chann].program[0], strlen(kanaler[chann].program[0]));
    tempstr[31] = '\0';
    if (max_x-(59+bordercfg) < 32) {
        tempstr[max_x-(59+bordercfg)-1] = '\0';
    }
    mvprintw(topspacecfg+clockcfg+chann,59+bordercfg,"%s", tempstr);
    attroff(A_BOLD);
}


void print_curr_prgms(int chann) {

    time_t         t		= time(NULL);
    struct tm      *tid		= localtime(&t);
    int            i, mn_mins	= ((((tid->tm_hour)%24)*60)+ tid->tm_min);  // mins since midnight

    for (i=0;i<MAXCHAN && kanaler[chann].program[i][0] != '\0' ;i++) { 
        if (kanaler[chann].starttid[i] <= mn_mins && kanaler[chann].starttid[i+1] > mn_mins) {
            actual_print(chann, i);
            return;
        }
    }
    // not caught by simple logic

    for (i=0;i<MAXCHAN && kanaler[chann].program[i][0] != '\0' ;i++) {
        if (kanaler[chann].starttid[i] <= mn_mins && kanaler[chann].starttid[i+1] < kanaler[chann].starttid[i]) {
            if (kanaler[chann].starttid[0] > mn_mins && mn_mins >= 360) {
                special_print(chann);
                return;
            }
            actual_print(chann, i);
            return;
        }
        else if (kanaler[chann].starttid[i] > mn_mins && kanaler[chann].starttid[i+1] > mn_mins &&
                kanaler[chann].starttid[i] > kanaler[chann].starttid[i+1]) {
            actual_print(chann, i);
            return;     		
        }
    }
    // are we at the last program, after the last program of before the first?   

    if (mn_mins < kanaler[chann].starttid[i-1])
        actual_print(chann, 0);
    else
        actual_print(chann, i-1);
}

void print_all(char ww, WINDOW *wwn, char wt, WINDOW *wtn ) {

    int i;

    if (clockcfg == 1)
        print_time(max_x);
    print_channels();

    for (i=0;i<16;i++) {
        if (kanaler[i].used != 1) break;
        print_curr_prgms(i);    
    }
    refresh();
    if (ww == 1) {
        touchwin(wwn);
        wrefresh(wwn);
    }
    if (wt == 1) {
        touchwin(wtn);
        wrefresh(wtn);
    }
}

WINDOW *print_reload_win(void) {

    WINDOW *reloadwin;
    reloadwin = newwin(3, 20, (max_y/2)-1,(max_x/2)-10);

    if (has_colors() == TRUE && colorcfg == 1) {
        wattron(reloadwin,COLOR_PAIR(7));
    }
    box(reloadwin,0,0);

    if (has_colors() == TRUE && colorcfg == 1) {
        wattron(reloadwin,COLOR_PAIR(8));
    }

    mvwprintw(reloadwin,1,2,"Reloading...");

    wrefresh(reloadwin);
    return reloadwin;
}

WINDOW *print_watch_win(void) {

    int i,j=0;
    WINDOW *watchwin;

    for (i=0; i < MAXWATCH; i++) {
        if(watch[i][0] == '\0') break;
        j++;
    }
    if (j == 0) {
        /* no watches set */ 
        watchwin = newwin(3, 34, (max_y/2)-1,(max_x/2)-17);
        if (has_colors() == TRUE && colorcfg == 1) {
            wattron(watchwin,COLOR_PAIR(7));
        }
        box(watchwin,0,0);

        if (has_colors() == TRUE && colorcfg == 1) {
            wattron(watchwin,COLOR_PAIR(8));
        }
        mvwprintw(watchwin,1,2,"No watches set...");
        wrefresh(watchwin);
        return watchwin;
    }
    /* open the watch win.. if it fails print another win with errormsg */
    if ((watchwin = newwin(j+2, 34, (max_y/2)-(j/2)-1,(max_x/2)-17)) == NULL ) {
        watchwin = newwin(3, 41, (max_y/2)-1,(max_x/2)-20);
        if (has_colors() == TRUE && colorcfg == 1) {
            wattron(watchwin,COLOR_PAIR(7));
        }
        box(watchwin,0,0);

        if (has_colors() == TRUE && colorcfg == 1) {
            wattron(watchwin,COLOR_PAIR(8));
        }
        mvwprintw(watchwin,1,2,"Can't fit the watch window on screen!");
        wrefresh(watchwin);
        return watchwin;
    }


    if (has_colors() == TRUE && colorcfg == 1) {
        wattron(watchwin,COLOR_PAIR(7));
    }
    box(watchwin,0,0);

    if (has_colors() == TRUE && colorcfg == 1) {
        wattron(watchwin,COLOR_PAIR(8));
    }

    for (i=0; i<=j; i++) {
        mvwprintw(watchwin,1+i,2,"%s",watch[i]);
    }
    wrefresh(watchwin);
    return watchwin;
}


void kill_win(WINDOW *killwin) {

    delwin(killwin);
    clear();
}
void check_resize(char ww, WINDOW *wwn, char wt, WINDOW *wtn) {

    int x, y;

    getmaxyx(stdscr,y,x);
    mvprintw(max_y-bordercfg-1,max_x-bordercfg-1,""); //why the fuck is this needed?
    if ((x != max_x) || (y != max_y)) {
        getmaxyx(stdscr,max_y,max_x);
        clear();
        printf("\033[?25l"); // aterm seems to turn the cursor back on when resizeing
        print_border();
        print_all(ww, wwn, wt, wtn);
    }

}


void print_border(void) {

    if (bordercfg == 1) {
        if (has_colors() == TRUE && colorcfg == 1) {
            attron(COLOR_PAIR(7));
        }
        box(stdscr, 0, 0);   
    }
    getmaxyx(stdscr,max_y,max_x);
    refresh(); 
}

void init_colors() {

    if (has_colors() == TRUE && colorcfg == 1) {  // colors if avail and wanted
        start_color();
        use_default_colors();
        
        init_pair(1, COLOR_RED, -1);  // channel color
        init_pair(2, COLOR_CYAN, -1);  // time color
        init_pair(3, COLOR_GREEN, -1);  // program color
        init_pair(4, COLOR_RED, -1); // clock color
        init_pair(5, COLOR_CYAN, -1); // next prgtime color
        init_pair(6, COLOR_BLUE, -1); // next prg color
        init_pair(7, COLOR_MAGENTA, -1); // boxborder color   
        init_pair(8, COLOR_WHITE, -1);  // textcolor (reloading, watch)
    }
}

WINDOW *print_todays_watch(void) {

    int i,j=0,k,l;
    WINDOW *watchwin;

    for (k = 0; k < 16 && kanaler[k].used == 1; k++) {
        for (l = 0; l < MAXCHAN && kanaler[k].program[l][0] != ' '; l++) {  
            if (kanaler[k].watch[l] == 1) {
                j++;
            }
        }
    }
    
    if (j == 0) {
        /* no watches today */ 
        watchwin = newwin(3, 34, (max_y/2)-1,(max_x/2)-17);
        if (has_colors() == TRUE && colorcfg == 1) {
            wattron(watchwin,COLOR_PAIR(7));
        }
        box(watchwin,0,0);

        if (has_colors() == TRUE && colorcfg == 1) {
            wattron(watchwin,COLOR_PAIR(8));
        }
        mvwprintw(watchwin,1,2,"No watches today...");
        wrefresh(watchwin);
        return watchwin;
    }
    /* open the watch win.. if it fails print another win with errormsg */
    if ((watchwin = newwin(j+2, 54, (max_y/2)-(j/2)-1,(max_x/2)-27)) == NULL ) {
        watchwin = newwin(3, 41, (max_y/2)-1,(max_x/2)-20);
        if (has_colors() == TRUE && colorcfg == 1) {
            wattron(watchwin,COLOR_PAIR(7));
        }
        box(watchwin,0,0);

        if (has_colors() == TRUE && colorcfg == 1) {
            wattron(watchwin,COLOR_PAIR(8));
        }
        mvwprintw(watchwin,1,2,"Can't fit todays watches on screen!");
        wrefresh(watchwin);
        return watchwin;
    }


    if (has_colors() == TRUE && colorcfg == 1) {
        wattron(watchwin,COLOR_PAIR(7));
    }
    box(watchwin,0,0);

    if (has_colors() == TRUE && colorcfg == 1) {
        wattron(watchwin,COLOR_PAIR(8));
    }
    i=0;
    for (k = 0; k < 16 && kanaler[k].used == 1; k++) {
        for (l = 0; l < MAXCHAN && kanaler[k].program[l][0] != ' '; l++) {  
            if (kanaler[k].watch[l] == 1) {
                mvwprintw(watchwin, 1+i,2,"%-13.13s %.2d:%.2d %-13.31s",kanaler[k].name,(kanaler[k].starttid[l] - kanaler[k].starttid[l]%60)/60, kanaler[k].starttid[l]%60, kanaler[k].program[l]);
                i++;
            }
        }
    }
    
    
    wrefresh(watchwin);
    return watchwin;
}


